Open Cascade造型演算法——倒圓與倒角
造型演算法——倒圓與倒角
Modeling Algorithms Fillets and Chamfers
一、倒圓Fillet Constructor
1. BRepFilletAPI_MakeFillet
使用類BRepFilletAPI_MakeFillet來為形狀新增倒圓。倒圓是用光滑面來代替角邊。使用方法如下:
l 首先,給定一個需要倒圓的形狀;
l 然後,通過Add方法來新增描述倒圓的引數,倒圓所需的引數包括一個邊edge和半徑radius。當然,邊edge必須由兩個面face所共有。倒圓會將原來的邊替換成光滑的圓面過渡。
l 最後,通過詢問結果來執行倒圓操作。
注:新增一個倒圓兩次並不會出錯,因為只保留了最後一次添的倒圓。
Figure 1. Filleting two edges using radius r1 and r2
下面給出一個將建立一個倒圓的長方體,其尺寸分別為a,b,c,倒圓半徑r。
Figure 2. Filleting a box
程式碼如下所示,建立上圖所示的倒圓的長方體的引數分別為:
a = 100,b = 60,c = 80,r = 10:
#include <TopoDS_Shape.hxx>#include <TopoDS.hxx>#include <BRepPrimAPI_MakeBox.hxx>#include <TopoDS_Solid.hxx>#include <BRepFilletAPI_MakeFillet.hxx>#include <TopExp_Explorer.hxx>TopoDS_Shape FilletedBox(const Standard_Real a,
const Standard_Real b,
const Standard_Real c,
const Standard_Real r)
{TopoDS_Solid Box = BRepPrimAPI_MakeBox(a,b,c);BRepFilletAPI_MakeFillet MF(Box);// add all the edges to fillet
TopExp_Explorer ex(Box,TopAbs_EDGE);while (ex.More())
{MF.Add(r,TopoDS::Edge(ex.Current()));ex.Next();}return MF.Shape();
}
如下圖所示為建立一個半徑變化的倒圓操作:
Figure 3. Evolutive radius fillet
Figure 4. Evolutive radius fillet a box
程式程式碼如下所示:
1: TopoDS_Shape theBox = BRepPrimAPI_MakeBox(200, 200, 200);2: BRepFilletAPI_MakeFillet Rake(theBox);3: ChFi3d_FilletShape FSH = ChFi3d_Rational;4: Rake.SetFilletShape(FSH);5:6: TColgp_Array1OfPnt2d parAndRad(1, 6);7: parAndRad.SetValue(1, gp_Pnt2d(0, 10));8: parAndRad.SetValue(2, gp_Pnt2d(50, 20));9: parAndRad.SetValue(3, gp_Pnt2d(70, 20));10: parAndRad.SetValue(4, gp_Pnt2d(130, 60));11: parAndRad.SetValue(5, gp_Pnt2d(160, 30));12: parAndRad.SetValue(6, gp_Pnt2d(200, 20));13:14: TopExp_Explorer ex(theBox, TopAbs_EDGE);15: Rake.Add(parAndRad, TopoDS::Edge(ex.Current()));16: TopoDS_Shape evolvedBox = Rake.Shape();17:
2. BRepFilletAPI_MakeFillet2d
BRepFilletAPI_MakeFillet2d is used to construct fillets and chamfers on planar faces.
我按照示例程式碼運行了一下程式,結果程式總是崩潰,其操作的效果不得而知,所以也得不到真實的效果圖。將其程式程式碼列出如下所示:
1: #include “BRepPrimAPI_MakeBox.hxx”2: #include “TopoDS_Shape.hxx”3: #include “TopExp_Explorer.hxx”4: #include “BRepFilletAPI_MakeFillet2d.hxx”5: #include “TopoDS.hxx”6: #include “TopoDS_Solid.hxx”7:8: TopoDS_Shape FilletFace(const Standard_Real a,
9: const Standard_Real b,
10: const Standard_Real c,
11: const Standard_Real r)
12: {13: TopoDS_Solid Box = BRepPrimAPI_MakeBox (a,b,c);14: TopExp_Explorer ex1(Box,TopAbs_FACE);15:16: const TopoDS_Face& F = TopoDS::Face(ex1.Current());
17: BRepFilletAPI_MakeFillet2d MF(F);18: TopExp_Explorer ex2(F, TopAbs_VERTEX);19:20: while (ex2.More())
21: {22: MF.AddFillet(TopoDS::Vertex(ex2.Current()),r);23: ex2.Next();24: }25:26: // while...
27: return MF.Shape();
28: }29:
二、倒角Chamfer Constructor
1.BRepFilletAPI_MakeChamfer
類BREpFilletAPI_MakeChamfer的使用方法與BRepFilletAPI_MakeFillet大致類似,但稍有不同:
a) The surfaces created are ruled and not smooth;
b) The Add syntax for selecting edges requires one or two distances, one edge and one face(contiguous to the edge);
Add(dist, E, F);
Add(d1, d2, E, F); with d1 on the face F.
Figure 5. Creating a chamfer
Figure 6. The box with chamfers
程式程式碼如下所示:
1: TopoDS_Shape theBox = BRepPrimAPI_MakeBox(130,200,170);2: BRepFilletAPI_MakeChamfer MC(theBox);3: TopTools_IndexedDataMapOfShapeListOfShape M;4: TopExp::MapShapesAndAncestors(theBox,TopAbs_EDGE,TopAbs_FACE,M);5:6: for (Standar1d_Integer i;i<M.Extent();i++)
7: {8: TopoDS_Edge E = TopoDS::Edge(M.FindKey(i));9: TopoDS_Face F = TopoDS::Face(M.FindFromIndex(i).First());10: MC.Add(15,15,E,F);11: }12:13: TopoDS_Shape ChanfrenedBox = MC.Shape();14: